"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var quickjs_emscripten_module_1 = __importDefault(require("./quickjs-emscripten-module"));
var ffi_1 = require("./ffi");
var isReady = false;
var QuickJSModule = quickjs_emscripten_module_1.default();
/**
 * This promise will be fufilled when the QuickJS emscripten module has initialized
 * and the {@link QuickJS} instance can be created.
 */
var ready = new Promise(function (resolve) {
    QuickJSModule.onRuntimeInitialized = resolve;
}).then(function () {
    isReady = true;
});
/**
 * A lifetime prevents access to a value after the lifetime has been
 * [[dispose]]ed.
 *
 * Typically, quickjs-emscripten uses Lifetimes to protect C memory pointers.
 */
var Lifetime = /** @class */ (function () {
    /**
     * When the Lifetime is disposed, it will call `disposer(_value)`. Use the
     * disposer function to implement whatever cleanup needs to happen at the end
     * of `value`'s lifetime.
     *
     * `_owner` is not used or controlled by the lifetime. It's just metadata for
     * the creator.
     */
    function Lifetime(_value, disposer, _owner) {
        this._value = _value;
        this.disposer = disposer;
        this._owner = _owner;
        this._alive = true;
    }
    Object.defineProperty(Lifetime.prototype, "alive", {
        get: function () {
            return this._alive;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Lifetime.prototype, "value", {
        /**
         * The value this Lifetime protects. You must never retain the value - it
         * may become invalid, leading to memory errors.
         *
         * @throws If the lifetime has been [[dispose]]d already.
         */
        get: function () {
            this.assertAlive();
            return this._value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Lifetime.prototype, "owner", {
        get: function () {
            return this._owner;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Dispose of [[value]] and perform cleanup.
     */
    Lifetime.prototype.dispose = function () {
        this.assertAlive();
        if (this.disposer) {
            this.disposer(this._value);
        }
        this._alive = false;
    };
    Lifetime.prototype.assertAlive = function () {
        if (!this.alive) {
            throw new Error('Lifetime not alive');
        }
    };
    return Lifetime;
}());
exports.Lifetime = Lifetime;
/**
 * A Lifetime that lives forever. Used for constants.
 */
var StaticLifetime = /** @class */ (function (_super) {
    __extends(StaticLifetime, _super);
    function StaticLifetime() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // Dispose does nothing.
    StaticLifetime.prototype.dispose = function () { };
    return StaticLifetime;
}(Lifetime));
exports.StaticLifetime = StaticLifetime;
/**
 * QuickJSVm wraps a QuickJS Javascript runtime (JSRuntime*) and context (JSContext*).
 * This class's methods return {@link QuickJSHandle}, which wrap C pointers (JSValue*).
 * It's the caller's responsibility to call `.dispose()` on any
 * handles you create to free memory once you're done with the handle.
 *
 * Each QuickJSVm instance is isolated. You cannot share handles between different
 * QuickJSVm instances. You should create separate QuickJSVm instances for
 * untrusted code from different souces for isolation.
 *
 * Use [[QuickJS.createVm]] to create a new QuickJSVm.
 *
 * Create QuickJS values with methods like [[newNumber]], [[newString]], [[newObject]], and [[newFunction]].
 *
 * Call [[setProp]] or [[defineProp]] to customize objects. Use those methods with [[global]] to expose the
 * values you create to the interior of the interpreter, so they can be used in [[evalCode]].
 */
var QuickJSVm = /** @class */ (function () {
    /**
     * Use {@link QuickJS.createVm} to create a QuickJSVm instance.
     */
    function QuickJSVm(args) {
        var _this = this;
        this._undefined = undefined;
        this._global = undefined;
        this.lifetimes = [];
        this.fnNextId = 0;
        this.fnMap = new Map();
        /**
         * @hidden
         */
        this.cToHostCallbackFunction = function (ctx, this_ptr, argc, argv, fn_data) {
            if (ctx !== _this.ctx.value) {
                throw new Error('QuickJSVm instance received C -> JS call with mismatched ctx');
            }
            var fnId = _this.ffi.QTS_GetFloat64(ctx, fn_data);
            var fn = _this.fnMap.get(fnId);
            if (!fn) {
                throw new Error("QuickJSVm had no callback with id " + fnId);
            }
            var thisHandle = new Lifetime(this_ptr, undefined, _this);
            var argHandles = new Array(argc);
            for (var i = 0; i < argc; i++) {
                var ptr = _this.ffi.QTS_ArgvGetJSValueConstPointer(argv, i);
                argHandles[i] = new Lifetime(ptr, undefined, _this);
            }
            var ownedResultPtr = 0;
            try {
                var result = fn.apply(thisHandle, argHandles);
                if (result) {
                    if ('error' in result && result.error) {
                        throw result.error;
                    }
                    var handle = result instanceof Lifetime ? result : result.value;
                    ownedResultPtr = _this.ffi.QTS_DupValue(_this.ctx.value, handle.value);
                    handle.dispose();
                }
            }
            catch (error) {
                var errorHandle = _this.errorToHandle(error);
                ownedResultPtr = _this.ffi.QTS_Throw(_this.ctx.value, errorHandle.value);
                errorHandle.dispose();
            }
            // Free the arguments so they can't be retained and re-used after we return.
            if (thisHandle.alive) {
                thisHandle.dispose();
            }
            for (var _i = 0, argHandles_1 = argHandles; _i < argHandles_1.length; _i++) {
                var argHandle = argHandles_1[_i];
                if (argHandle.alive) {
                    argHandle.dispose();
                }
            }
            return ownedResultPtr;
        };
        this.freeJSValue = function (ptr) {
            _this.ffi.QTS_FreeValuePointer(_this.ctx.value, ptr);
        };
        this.module = args.module;
        this.ffi = args.ffi;
        this.ctx = args.ctx;
        this.rt = args.rt;
    }
    Object.defineProperty(QuickJSVm.prototype, "undefined", {
        /**
         * [`undefined`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/undefined).
         */
        get: function () {
            if (this._undefined) {
                return this._undefined;
            }
            // Undefined is a constant, immutable value in QuickJS.
            var ptr = this.ffi.QTS_GetUndefined();
            return (this._undefined = new StaticLifetime(ptr));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(QuickJSVm.prototype, "global", {
        /**
         * [`global`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects).
         * A handle to the global object inside the interpreter.
         * You can set properties to create global variables.
         */
        get: function () {
            if (this._global) {
                return this._global;
            }
            // The global is a JSValue, but since it's lifetime is as long as the VM's,
            // we should manage it.
            var ptr = this.ffi.QTS_GetGlobalObject(this.ctx.value);
            // Automatically clean up this reference when we dispose(
            this.lifetimes.push(this.heapValueHandle(ptr));
            // This isn't technically a static lifetime, but since it has the same
            // lifetime as the VM, it's okay to fake one since when the VM iss
            // disposed, no other functions will accept the value.
            this._global = new StaticLifetime(ptr, undefined, this);
            return this._global;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * `typeof` operator. **Not** [standards compliant](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/typeof).
     *
     * @remarks
     * Does not support BigInt values correctly.
     */
    QuickJSVm.prototype.typeof = function (handle) {
        this.assertOwned(handle);
        return this.ffi.QTS_Typeof(this.ctx.value, handle.value);
    };
    /**
     * Converts a Javascript number into a QuckJS value.
     */
    QuickJSVm.prototype.newNumber = function (num) {
        return this.heapValueHandle(this.ffi.QTS_NewFloat64(this.ctx.value, num));
    };
    /**
     * Converts `handle` into a Javascript number.
     * @returns `NaN` on error, othewise a `number`.
     */
    QuickJSVm.prototype.getNumber = function (handle) {
        this.assertOwned(handle);
        return this.ffi.QTS_GetFloat64(this.ctx.value, handle.value);
    };
    /**
     * Create a QuickJS [string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String) value.
     */
    QuickJSVm.prototype.newString = function (str) {
        return this.heapValueHandle(this.ffi.QTS_NewString(this.ctx.value, str));
    };
    /**
     * Converts `handle` to a Javascript string.
     */
    QuickJSVm.prototype.getString = function (handle) {
        this.assertOwned(handle);
        return this.ffi.QTS_GetString(this.ctx.value, handle.value);
    };
    /**
     * `{}`.
     * Create a new QuickJS [object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer).
     *
     * @param prototype - Like [`Object.create`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/create).
     */
    QuickJSVm.prototype.newObject = function (prototype) {
        if (prototype) {
            this.assertOwned(prototype);
        }
        var ptr = prototype
            ? this.ffi.QTS_NewObjectProto(this.ctx.value, prototype.value)
            : this.ffi.QTS_NewObject(this.ctx.value);
        return this.heapValueHandle(ptr);
    };
    /**
     * Convert a Javascript function into a QuickJS function value.
     * See [[VmFunctionImplementation]] for more details.
     *
     * A [[VmFunctionImplementation]] should not free its arguments or its retun
     * value. A VmFunctionImplementation should also not retain any references to
     * its veturn value.
     */
    QuickJSVm.prototype.newFunction = function (name, fn) {
        var fnId = ++this.fnNextId;
        this.fnMap.set(fnId, fn);
        var fnIdHandle = this.newNumber(fnId);
        var funcHandle = this.heapValueHandle(this.ffi.QTS_NewFunction(this.ctx.value, fnIdHandle.value, name));
        // We need to free fnIdHandle's pointer, but not the JSValue, which is retained inside
        // QuickJS for late.
        this.module._free(fnIdHandle.value);
        return funcHandle;
    };
    /**
     * `handle[key]`.
     * Get a property from a JSValue.
     *
     * @param key - The property may be specified as a JSValue handle, or as a
     * Javascript string (which will be converted automatically).
     */
    QuickJSVm.prototype.getProp = function (handle, key) {
        this.assertOwned(handle);
        var quickJSKey = typeof key === 'string' ? this.newString(key) : key;
        var ptr = this.ffi.QTS_GetProp(this.ctx.value, handle.value, quickJSKey.value);
        var result = this.heapValueHandle(ptr);
        if (typeof key === 'string') {
            // we allocated a string
            quickJSKey.dispose();
        }
        return result;
    };
    /**
     * `handle[key] = value`.
     * Set a property on a JSValue.
     *
     * @remarks
     * Note that the QuickJS authors recommend using [[defineProp]] to define new
     * properties.
     *
     * @param key - The property may be specified as a JSValue handle, or as a
     * Javascript string (which will be converted automatically).
     */
    QuickJSVm.prototype.setProp = function (handle, key, value) {
        this.assertOwned(handle);
        var quickJSKey = typeof key === 'string' ? this.newString(key) : key;
        this.ffi.QTS_SetProp(this.ctx.value, handle.value, quickJSKey.value, value.value);
        if (typeof key === 'string') {
            // we allocated a string
            quickJSKey.dispose();
        }
    };
    /**
     * [`Object.defineProperty(handle, key, descriptor)`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperty).
     *
     * @param key - The property may be specified as a JSValue handle, or as a
     * Javascript string (which will be converted automatically).
     */
    QuickJSVm.prototype.defineProp = function (handle, key, descriptor) {
        this.assertOwned(handle);
        var quickJSKey = typeof key === 'string' ? this.newString(key) : key;
        var value = descriptor.value || this.undefined;
        var configurable = Boolean(descriptor.configurable);
        var enumerable = Boolean(descriptor.enumerable);
        var hasValue = Boolean(descriptor.value);
        var get = descriptor.get
            ? this.newFunction(descriptor.get.name, descriptor.get)
            : this.undefined;
        var set = descriptor.set
            ? this.newFunction(descriptor.set.name, descriptor.set)
            : this.undefined;
        this.ffi.QTS_DefineProp(this.ctx.value, handle.value, quickJSKey.value, value.value, get.value, set.value, configurable, enumerable, hasValue);
        if (typeof key === 'string') {
            // we allocated a string
            quickJSKey.dispose();
        }
    };
    /**
     * [`func.call(thisVal, ...args)`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/call).
     * Call a JSValue as a function.
     *
     * See [[unwrapResult]], which will throw if the function returned an error, or
     * return the result handle directly.
     *
     * @returns A result. If the function threw, result `error` be a handle to the exception.
     */
    QuickJSVm.prototype.callFunction = function (func, thisVal) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        this.assertOwned(func);
        var argsArrayPtr = this.toPointerArray(args);
        var resultPtr = this.ffi.QTS_Call(this.ctx.value, func.value, thisVal.value, args.length, argsArrayPtr.value);
        argsArrayPtr.dispose();
        var errorPtr = this.ffi.QTS_ResolveException(this.ctx.value, resultPtr);
        if (errorPtr) {
            this.ffi.QTS_FreeValuePointer(this.ctx.value, resultPtr);
            return { error: this.heapValueHandle(errorPtr) };
        }
        return { value: this.heapValueHandle(resultPtr) };
    };
    /**
     * Like [`eval(code)`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/eval#Description).
     * Evauatetes the Javascript source `code` in the global scope of this VM.
     *
     * See [[unwrapResult]], which will throw if the function returned an error, or
     * return the result handle directly.
     *
     * *Note: this does not protect against infinite loops*.
     *
     * @returns The last statement's value. If the code threw, result `error` be
     * a handle to the exception.
     */
    QuickJSVm.prototype.evalCode = function (code) {
        var resultPtr = this.ffi.QTS_Eval(this.ctx.value, code);
        var errorPtr = this.ffi.QTS_ResolveException(this.ctx.value, resultPtr);
        if (errorPtr) {
            this.ffi.QTS_FreeValuePointer(this.ctx.value, resultPtr);
            return { error: this.heapValueHandle(errorPtr) };
        }
        return { value: this.heapValueHandle(resultPtr) };
    };
    // customizations
    /**
     * Dump a JSValue to Javascript in a best-effort fashion.
     * Returns `handle.toString()` if it cannot be serialized to JSON.
     */
    QuickJSVm.prototype.dump = function (handle) {
        this.assertOwned(handle);
        var type = this.typeof(handle);
        if (type === 'string') {
            return this.getString(handle);
        }
        else if (type === 'number') {
            return this.getNumber(handle);
        }
        else if (type === 'undefined') {
            return undefined;
        }
        var str = this.ffi.QTS_Dump(this.ctx.value, handle.value);
        try {
            return JSON.parse(str);
        }
        catch (err) {
            return str;
        }
    };
    /**
     * Unwrap a VmCallResult, returning it's value on success, and throwing the dumped
     * error on failure.
     */
    QuickJSVm.prototype.unwrapResult = function (result) {
        if (result.error) {
            var dumped = this.dump(result.error);
            result.error.dispose();
            if (dumped && typeof dumped === 'object' && typeof dumped.message === 'string') {
                var exception = new Error(dumped.message);
                if (typeof dumped.name === 'string') {
                    exception.name = dumped.name;
                }
                throw exception;
            }
            throw dumped;
        }
        return result.value;
    };
    /**
     * Dispose of this VM's underlying resources.
     *
     * @throws If Calling this method without disposing of all created handles
     * will result in an error.
     */
    QuickJSVm.prototype.dispose = function () {
        for (var _i = 0, _a = this.lifetimes; _i < _a.length; _i++) {
            var lifetime = _a[_i];
            if (lifetime.alive) {
                lifetime.dispose();
            }
        }
        this.ctx.dispose();
        this.rt.dispose();
    };
    QuickJSVm.prototype.assertOwned = function (handle) {
        if (handle.owner && handle.owner !== this) {
            throw new Error('Given handle created by a different VM');
        }
    };
    QuickJSVm.prototype.heapValueHandle = function (ptr) {
        return new Lifetime(ptr, this.freeJSValue, this);
    };
    QuickJSVm.prototype.toPointerArray = function (handleArray) {
        var _this = this;
        var typedArray = new Int32Array(handleArray.map(function (handle) { return handle.value; }));
        var numBytes = typedArray.length * typedArray.BYTES_PER_ELEMENT;
        var ptr = this.module._malloc(numBytes);
        var heapBytes = new Uint8Array(this.module.HEAPU8.buffer, ptr, numBytes);
        heapBytes.set(new Uint8Array(typedArray.buffer));
        return new Lifetime(ptr, function (ptr) { return _this.module._free(ptr); });
    };
    QuickJSVm.prototype.errorToHandle = function (error) {
        if (error instanceof Lifetime) {
            return error;
        }
        var errorHandle = this.heapValueHandle(this.ffi.QTS_NewError(this.ctx.value));
        if (error.name !== undefined) {
            var handle = this.newString(error.name);
            this.setProp(errorHandle, 'name', handle);
            handle.dispose();
        }
        if (error.message !== undefined) {
            var handle = this.newString(error.message);
            this.setProp(errorHandle, 'message', handle);
            handle.dispose();
        }
        if (error.stack !== undefined) {
            var handle = this.newString(error.stack);
            // Set to fullStack...? For debugging.
            //this.setProp(errorHandle, 'fullStack', handle)
            handle.dispose();
        }
        return errorHandle;
    };
    return QuickJSVm;
}());
exports.QuickJSVm = QuickJSVm;
/**
 * QuickJS presents a Javascript interface to QuickJS, a Javascript interpreter that
 * supports ES2019.
 *
 * QuickJS is a singleton. Use the [[getQuickJS]] function to instantiate
 * or retrieve an instance.
 *
 * Use the {@link QuickJS.createVm} method to create a {@link QuickJSVm}.
 *
 * Use the {@link QuickJS.evalCode} method as a shortcut evaluate Javascript safely
 * and return the result as a native Javascript value.
 */
var QuickJS = /** @class */ (function () {
    function QuickJS() {
        var _this = this;
        this.ffi = new ffi_1.QuickJSFFI(QuickJSModule);
        this.vmMap = new Map();
        this.module = QuickJSModule;
        // We need to send this into C-land
        this.cToHostCallbackFunction = function (ctx, this_ptr, argc, argv, fn_data_ptr) {
            try {
                var vm = _this.vmMap.get(ctx);
                if (!vm) {
                    var fn_name = _this.ffi.QTS_GetString(ctx, fn_data_ptr);
                    throw new Error("QuickJSVm(ctx = " + ctx + ") not found for C function call \"" + fn_name + "\"");
                }
                return vm.cToHostCallbackFunction(ctx, this_ptr, argc, argv, fn_data_ptr);
            }
            catch (error) {
                console.error('[C to host error: returning null]', error);
                return 0;
            }
        };
        if (!isReady) {
            throw new Error('QuickJS WASM module not initialized. Either wait for `ready` or use getQuickJS()');
        }
        if (singleton) {
            throw new Error('Cannot create another QuickJS instance. Use the instance already created (try getQuickJS())');
        }
        singleton = this;
        // This is why we need to be a singleton: each Emscripten module of QuickJS needs
        // a single C callback dispatcher.
        var pointerType = 'i';
        var intType = 'i';
        var wasmTypes = [
            pointerType,
            pointerType,
            pointerType,
            intType,
            pointerType,
            pointerType,
        ];
        var fp = this.module.addFunction(this.cToHostCallbackFunction, wasmTypes.join(''));
        this.ffi.QTS_SetHostCallback(fp);
    }
    /**
     * Create a QuickJS VM.
     *
     * Each VM is completely independent - you cannot share handles between
     * VMs.
     */
    QuickJS.prototype.createVm = function () {
        var _this = this;
        var rt = new Lifetime(this.ffi.QTS_NewRuntime(), function (rt_ptr) { return _this.ffi.QTS_FreeRuntime(rt_ptr); });
        var ctx = new Lifetime(this.ffi.QTS_NewContext(rt.value), function (ctx_ptr) {
            _this.vmMap.delete(ctx_ptr);
            _this.ffi.QTS_FreeContext(ctx_ptr);
        });
        var vm = new QuickJSVm({
            module: this.module,
            ffi: this.ffi,
            rt: rt,
            ctx: ctx,
        });
        this.vmMap.set(ctx.value, vm);
        return vm;
    };
    /**
     * One-off evaluate code without needing to create a VM.
     * The result is coerced to a native Javascript value using JSON
     * serialization, so values unsupported by JSON will be dropped.
     *
     * If you need more control over how the code executes, create a
     * [[QuickJSVm]] instance and use its [[QuickJSVm.evalCode]] method.
     *
     * *Note: this does not protect against infinite loops.*
     *
     * @throws If `code` throws during evaluation, the exception will be
     * converted into a Javascript value and throw.
     */
    QuickJS.prototype.evalCode = function (code) {
        var vm = this.createVm();
        var result = vm.evalCode(code);
        if (result.error) {
            var error = vm.dump(result.error);
            result.error.dispose();
            vm.dispose();
            throw error;
        }
        var value = vm.dump(result.value);
        result.value.dispose();
        vm.dispose();
        return value;
    };
    return QuickJS;
}());
exports.QuickJS = QuickJS;
var singleton = undefined;
/**
 * This is the top-level entrypoint for the quickjs-emscripten library.
 * Get the root QuickJS API.
 */
function getQuickJS() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, ready];
                case 1:
                    _a.sent();
                    if (!singleton) {
                        singleton = new QuickJS();
                    }
                    return [2 /*return*/, singleton];
            }
        });
    });
}
exports.getQuickJS = getQuickJS;
//# sourceMappingURL=quickjs.js.map